*** Exercise 6.1 Antisocial behavior data

* 1.
use antisocial, clear

xtdescribe if anti<. , i(id) t(occ)

* 2.

recode occ 90=0 92=1 94=2, generate(time)

* 3.

regress anti time pov momage female childage hispanic black momwork married, ///
   vce(cluster id)

* 4.a,b

xtset id time

xtgee anti time pov momage female childage hispanic black momwork married, ///
   corr(unstructured) vce(robust)
estimates store un
estat wcorrelation

xtgee anti time pov momage female childage hispanic black momwork married, ///
   corr(exchangeable) vce(robust)
estimates store ex
estat wcorrelation

xtgee anti time pov momage female childage hispanic black momwork married, ///
   corr(ar1) vce(robust)
estimates store ar1
estat wcorrelation

* 4.c.
estimates table un ex ar1, star b(%5.3f) 

* 4.d
xtgee anti time pov momage female childage hispanic black momwork married, ///
   corr(independent) vce(robust)

* 5.

mixed anti time pov momage female childage hispanic black momwork married ///
  || id:, noconstant residuals(unstructured, t(time)) mle stddeviations nofetable 
estat wcorrelation

mixed anti time pov momage female childage hispanic black momwork married ///
  || id:, noconstant residuals(exchangeable) mle stddeviations nofetable 
estat wcorrelation
  
mixed anti time pov momage female childage hispanic black momwork married ///
  || id:, noconstant residuals(ar 1, t(time)) mle stddeviations nofetable 
estat wcorrelation

  
* 6.

mixed anti time pov momage female childage hispanic black momwork married ///
   || id: time, covariance(unstructured) mle stddeviations


* 7.
estat recovariance

matrix cov = r(Cov2)

global theta= .9335097^2

* variances
global var0 = cov[2,2] + 2* cov[2,1]* 0 + cov[1,1]* 0^2 + $theta 
global var1 = cov[2,2] + 2* cov[2,1]* 1 + cov[1,1]* 1^2 + $theta 
global var2 = cov[2,2] + 2* cov[2,1]* 2 + cov[1,1]* 2^2 + $theta 


* covariances
global cov01 = cov[2,2] + cov[2,1] * (0 + 1) + cov[1,1]* 0 * 1
global cov02 = cov[2,2] + cov[2,1] * (0 + 2) + cov[1,1]* 0 * 2
global cov12 = cov[2,2] + cov[2,1] * (1 + 2) + cov[1,1]* 1 * 2

* standard deviations
display sqrt($var0)
display sqrt($var1)
display sqrt($var2)


* correlations
display $cov01/sqrt($var0 * $var1)
display $cov02/sqrt($var0 * $var2)
display $cov12/sqrt($var1 * $var2)

estat wcorrelation
