*** Exercise 6.3 Adolescent-alcohol-use data

use alcuse, clear

generate age_coa = age_14*coa
generate age_peer = age_14*peer

* 1a. AR(1)
mixed alcuse age_14 coa peer age_coa age_peer || id:, ///
   noconstant residual(ar 1, t(age_14)) mle stddeviations
estimates store ar1  

* 1b. RI
mixed alcuse age_14 coa peer age_coa age_peer || id:, ///
   mle stddeviations
estimates store ri

* 1c. RI + AR(1)
mixed alcuse age_14 coa peer age_coa age_peer || id:, ///
   residuals(ar 1, t(age_14)) mle stddeviations
estimates store ri_ar1

* 1d. RI + hetero  
mixed alcuse age_14 coa peer age_coa age_peer || id:, ///
   residuals(independent, by(age_14)) mle stddeviations
estimates store ri_het  

* 1e. RC
mixed alcuse age_14 coa peer age_coa age_peer || id: ///
   age_14, covariance(unstructured) mle stddeviations
estimates store rc 

* 1f. RC + AR(1)
mixed alcuse age_14 coa peer age_coa age_peer || id: ///
   age_14, covariance(unstructured) residuals(ar 1, t(age_14)) ///
   mle stddeviations
estimates store rc_ar1  

* 1g. RC + hetero
mixed alcuse age_14 coa peer age_coa age_peer || id: ///
   age_14, covariance(unstructured) residual(independent, by(age_14)) ///
   mle stddeviations
estimates store rc_het

* 1h. unstr
mixed alcuse age_14 coa peer age_coa age_peer || id:, ///
    noconstant residuals(unstructured, t(age_14)) ///
    mle stddeviations
estimates store un

* 2. Comparison
estimates stats ri ar1 ri_ar1 ri_het rc rc_ar1 rc_het un


