*** Exercise 6.8 Covariance structure for random-intercept model with AR(1) errors

scalar alpha = 0.6
scalar sigmae2 = 1
scalar psi = 1
scalar standardd = sqrt(sigmae2/(1-alpha^2))

matrix correl=J(4,4,1)
forvalues lag=1/3{                 /* 3 lags (4 occasions) */
	scalar cov`lag' = psi + alpha^`lag' * standardd^2
	scalar corr`lag' = cov`lag'/(psi + standardd^2)
	local numcorr = 4-`lag'        /* # correlations for this lag */
	forvalues along=1/`numcorr'{   /* for each corr. at this lag  */
		local ii = `lag'+`along'   /* row for correlation  matrix */
		local jj = `ii'- `lag'     /* col. for correlation matrix */
		matrix correl[`ii',`jj'] = corr`lag'
		matrix correl[`jj',`ii'] = corr`lag'
	}
}

matrix list correl

display "covariances are " cov1 ", " cov2 ", " cov3 

display "correlations are " corr1 ", " corr2 ", " corr3 

