*** Exercise 7.4 Calcium-supplementation data

use calcium, clear

* 1.
generate years = time/52.177457

* 2.
label define t 0 "Placebo" 1 "Calcium"
label values treat t

sort id years
twoway line y years, connect(ascending) by(treat) ///
  ytitle(Bone mineral density) xtitle(Years)

* 3.
* 3a.
* 3b.
* 3c.
mixed y c.years##c.treat || id: years, covariance(unstructured) mle vce(robust)
estimates store rc

* 4.
mixed y c.years##c.treat || id:,  mle vce(robust)
lrtest rc ., force

* 5.
by id (years), sort: generate visit=_n
mixed y c.years##c.treat || id: years, covariance(unstructured) ///
   residuals(indep, by(visit)) mle vce(robust)
lrtest rc ., force
 
* 6.
estimates restore rc
predict traj, fitted
sort id years
twoway line traj years, connect(ascending) by(treat) ///
   ytitle(Bone mineral density) xtitle(Years)

* 7.
predict fixed, xb
twoway (line fixed years if treat==0, sort lpatt(dash)) ///
       (line fixed years if treat==1, sort lpatt(solid)), ///
	   legend(order(2 "Calcium" 1 "Placebo"))             ///
	   ytitle(Bone mineral density) xtitle(Years)

