*** Exercise 7.7 Adolescent-alcohol-use data

use alcuse, clear

* 1.

* 2.

* 3.

generate age_coa = age_14*coa
generate age_peer = age_14*peer
mixed alcuse coa peer age_14 age_coa age_peer || id: age_14, ///
  covariance(unstructured) mle vce(robust)
  
* 4.

predict traj, fitted

twoway (scatter alcuse age_14) (line traj age_14, sort) if coa==0, by(id, compact)


twoway (scatter alcuse age_14) (line traj age_14, sort) if coa==1, by(id, compact)

* 5.

estat wcorrelation

** "By hand"
estat recovariance
matrix cov = r(Cov2)
global theta= .3372922 

global var1 = cov[2,2] + 2* cov[2,1]* 0 + cov[1,1]* 0^2 + $theta 
global var2 = cov[2,2] + 2* cov[2,1]* 1 + cov[1,1]* 1^2 + $theta  
global var3 = cov[2,2] + 2* cov[2,1]* 2 + cov[1,1]* 2^2 + $theta  

global cov21 = cov[2,2]  + cov[2,1]* (0 + 1) + cov[1,1]* 0 * 1
global cov31 = cov[2,2]  + cov[2,1]* (0 + 2) + cov[1,1]* 0 * 2
global cov32 = cov[2,2]  + cov[2,1]* (1 + 2) + cov[1,1]* 1 * 2

display $cov21/sqrt($var1 * $var2)
display $cov31/sqrt($var1 * $var3)
display $cov32/sqrt($var2 * $var3)

estat wcorrelation, covariance

display $var1 " " $var2 " " $var3
display $cov21 " " $cov31 " " $cov32

* 6.

* 6a.
use alcuse, clear
drop age
reshape wide alcuse, i(id) j(age_14)

sem (alcuse0 <- L1@1 L2@0) (alcuse1 <- L1@1 L2@1) (alcuse2 <- L1@1 L2@2), ///
   means(L1 L2) noconstant vce(robust)

* 6b.
sem (alcuse0 <- L1@1 L2@0) (alcuse1 <- L1@1 L2@1) (alcuse2 <- L1@1 L2@2) ///
   (L1 <- coa peer _cons) (L2 <- coa peer _cons), cov(e.L1*e.L2)         ///
   noconstant vce(robust)
   
* 6c.   
   
* 6d.
sem (alcuse0 <- L1@1 L2@0) (alcuse1 <- L1@1 L2@1) (alcuse2 <- L1@1 L2@2)     ///
   (L1 <- coa peer _cons) (L2 <- coa peer _cons), cov(e.L1*e.L2) noconstant  ///
   var(e.alcuse0@lev1var) var(e.alcuse1@lev1var) var(e.alcuse2@lev1var)      ///
   vce(robust)

