***Exercise 8.4 Multi-center hypertension-trial data

* 1.
use bp, clear
replace time = 2*(time-3)

* 2.
sort center id time
twoway (line bp time, connect(ascending)), by(center)

* 3.
encode treat, generate(treatment)
mixed bp bp_base i.treatment time || center: || id:, reml dfmethod(kroger)

* 4.
* 4.a.
mixed bp bp_base i.treatment time c.time#c.time || center: || id:, reml dfmethod(kroger)

* 4.b.
mixed bp bp_base i.treatment##c.time || center: || id:, reml dfmethod(kroger)
testparm treatment#c.time

* 4.c.
quietly mixed bp bp_base i.treatment time || center: || id:, reml dfmethod(kroger)
estimates store mod1

mixed bp bp_base i.treatment time || center: || id: time, ///
   covariance(unstructured) reml dfmethod(kroger)
estimates store mod2
lrtest mod2 mod1

* display 0.5*chi2tail(1,r(chi2)) + 0.5*chi2tail(2,r(chi2))

* 4.d.
mixed bp bp_base i.treatment time || center: time, covariance(unstructured) ///
    || id: time, covariance(unstructured) reml dfmethod(kroger)
estimates store mod3
lrtest mod3 mod2

* 5

* 6
lincom 2.treatment - 3.treatment

* 7
predict yhat, fitted
sort center id time
twoway (line yhat time, connect(ascending)), by(center)

